#include <time.h>
#include <stdio.h>
#include <stdint.h>
#include <cstdlib>
#include <string.h>
#include "../include/iqdata.h"

int main()
{
  	//open
	fprintf(stdout,"|---------------------------------------------------|\n");
	fprintf(stdout,"|This is a demo program of Data Transfer for Linux. |\n");
       fprintf(stdout,"|It shows how to read the IQ data of the instrument |\n");
	fprintf(stdout,"|from the external PC and evaluate the speed of     |\n");
       fprintf(stdout,"|data transfer.                                     |\n");
	fprintf(stdout,"|---------------------------------------------------|\n");
	fprintf(stdout,"Open start...\n");
	if (iqdata_open() == false)
	{
		fprintf(stdout,"%s\n",iqdata_get_fail_msg());
		return -1;
	}
	fprintf(stdout,"Open is OK\n");
	char key_y2 = ' ';
	uint32_t MBytes = 1024 * 1024;
	uint32_t blocksize_mb = 200;// * 1024 * 1024;
	char* pbuffer = (char*)malloc(sizeof(char) * blocksize_mb * MBytes + 64);//if pcie mode, memory+64bytes.
	memset(pbuffer,0x0,blocksize_mb * MBytes + 64);
	//wait for ready to read data.
	fprintf(stdout,"Before reading the data, it is necessary to capture the instrument at least once.\n");

     while(true)
     {
		fprintf(stdout,"If you are ready to read, enter 'y' or 'Y',or enter another key to quit.\n");
		fprintf(stdout,"Is it OK? ['y' or 'Y'/others]: ");
		char key_y = ' ';
		bool on_off = false;
		scanf("%c",&key_y);

		float datasize_mb2 = 0;
		int datasize_mb = 0;
		bool enable_read = true;
		if (key_y == 'y' || key_y == 'Y')
		{
			fprintf(stdout,"Please intput datasize of IQ data to read[Unit:MB,Type:integer]: ");
			scanf("%f",&datasize_mb2);
			scanf("%c",&key_y);
			key_y = ' ';
			datasize_mb = (int)datasize_mb2;
			if (datasize_mb <= 0)
			{
				enable_read = false;
				fprintf(stderr,"Input error.(datasize <= 0)\n");
			}else
			{
				fprintf(stdout,"If you want to save read IQ data, enter 'y' or 'Y', or enter another key to read only.\n");
				fprintf(stdout,"Is it OK? ['y' or 'Y'/others]: ");
				scanf("%c",&key_y);
				if (key_y == 'y' || key_y == 'Y') on_off = true;
				scanf("%c",&key_y);
				key_y = ' ';
			}
		}else
		{
			fprintf(stderr,"Quitting demo.\n");
			break;
		}

		//ready to measure elapsed time of reading.
		struct timespec tp1,tp2;
		int offset = 0;	
		uint64_t read_offset = 0;			
		uint32_t remainsize = datasize_mb;
		double elapsedtime_ms = 0.0;
		double speed = 0.0;

	      if (enable_read)
	       {
			fprintf(stdout,"Read start...\n");
			while(true)
			{
				if (remainsize <= 0) break;
				if (remainsize <= blocksize_mb)
				{
					blocksize_mb = remainsize;
					remainsize = 0;
				}else
				{
					remainsize -= blocksize_mb;
				}

			      if (on_off == false)
			       {
					//QueryPerformanceCounter(&start);
					 clock_gettime(CLOCK_MONOTONIC, &tp1);
					if (iqdata_read(pbuffer,
								 &offset,
								 //datasize,
								 blocksize_mb * MBytes,
								 read_offset) == false)
					{
						fprintf(stdout,"%s\n",iqdata_get_fail_msg());
						//return -1;
						break;
					}
					//read_offset += blocksize_mb * MBytes;
				}else
				{
					//QueryPerformanceCounter(&start);
					 clock_gettime(CLOCK_MONOTONIC, &tp1);
					if (iqdata_readplus(pbuffer,
							 	&offset,
								 //datasize,
								 blocksize_mb * MBytes,
								 read_offset,
								 true,
								 (char*)"",
								 (char*)"") == false)
					{
						fprintf(stdout,"%s\n",iqdata_get_fail_msg());
						//return -1;
						break;
					}
				}
				read_offset += blocksize_mb * MBytes;

				//QueryPerformanceCounter(&end);
				clock_gettime(CLOCK_MONOTONIC, &tp2);
				elapsedtime_ms += (tp2.tv_sec - tp1.tv_sec) * 1.0e3 + (tp2.tv_nsec - tp1.tv_nsec) / 1.0e6;
			}
		}
		
		//show speed information
		if (elapsedtime_ms > 0.0)
		{
			fprintf(stdout,"Read is OK.\n");
			//double milisec = (end.QuadPart - start.QuadPart) * 1000 / freq.QuadPart;
			speed = datasize_mb / (elapsedtime_ms / 1000);
			fprintf(stdout,"Speed of data transfer: %.3f MB/s.\n",speed);
			fprintf(stdout,"Elapsed time of data transfer: %.3f ms.\n",elapsedtime_ms);
		}

		//query user whether go or quit
		fprintf(stdout,"\nDo you want to continue? ['y' or 'Y'/others to quit]: ");
		scanf("%c",&key_y2);
		if (key_y2 != 'y' && key_y2 != 'Y')
                {
		   fprintf(stdout,"quitting demo.\n");
		   break;
		}
		scanf("%c",&key_y2);
		key_y2 = ' ';
       }

	//free momery
	free(pbuffer);
	pbuffer = NULL;
	
	//close
	fprintf(stdout,"Close start...\n");
	if (iqdata_close() == false)
	{
		fprintf(stdout,"%s\n",iqdata_get_fail_msg());
		return -1;
	}
	fprintf(stdout,"Close is OK.\n");

	return 0;
  
}
