#!/bin/bash

# This is the demo installer for external data transfer interface for Linux
# Run this script as root (superuser).
# (C) Anritsu Corporation / www.anritsu.com - 2017
#

echo "The demo software will be installed..."
A=`whoami`

if [ $A != 'root' ]; then
   echo "You have to be root to run this script"
   exit 1;
fi

CURDIR=`pwd`

#load module
KERNEL_VER=$(uname -r)
rm -rf /lib/modules/${KERNEL_VER}/kernel/lib/nsawb.ko
cd ./driver64/module
cp nsawb.ko /lib/modules/${KERNEL_VER}/kernel/lib
cd /lib/modules/${KERNEL_VER}
depmod
modprobe -r nsawb
modprobe nsawb
cd $CURDIR

#copy .conf
cp driver64/config/cyusb.conf /etc/

mkdir -p /usr/lib64

rm -rf /usr/lib64/img
mkdir /usr/lib64/img
cp driver64/img/usauwb.img /usr/lib64/img/

# Remove stale versions of the libcyusb library
rm -f /usr/lib64/libcyusb.so* /usr/lib64/libcyusb.so*
rm -f /usr/lib64/libnsauwb.so* /usr/lib64/libnsauwb.so*
rm -f /usr/lib64/libnsawb.so* /usr/lib64/libnsawb.so*
rm -f /usr/lib64/libiqdata.so* /usr/lib64/libiqdata.so*

# Copy the libcyusb library into the system library folders.
cp driver64/libcyusb.so.1 /usr/lib64
ln -s /usr/lib64/libcyusb.so.1 /usr/lib64/libcyusb.so
cp driver64/libnsauwb.so.1 /usr/lib64
ln -s /usr/lib64/libnsauwb.so.1 /usr/lib64/libnsauwb.so
cp driver64/libnsawb.so.1 /usr/lib64
ln -s /usr/lib64/libnsawb.so.1 /usr/lib64/libnsawb.so
cp lib64/libiqdata.so /usr/lib64/libiqdata.so.1
ln -s /usr/lib64/libiqdata.so.1 /usr/lib64/libiqdata.so

# Set the LD_LIBRARY_PATH variable .
#echo "" >> /etc/ld.so.conf
#echo "/usr/lib64/" >> /etc/ld.so.conf #/etc/profile
#echo "" >> /etc/ld.so.conf

#ldconfig

make
make clean

cp bin/datatransfer_demo /usr/bin

echo "Installation completed successful."

